/*
 * Copyright (c) 2013. EMBL, European Bioinformatics Institute
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.ac.ebi.mnb.dialog.edit;

import org.apache.log4j.Logger;
import uk.ac.ebi.mdk.domain.entity.*;
import uk.ac.ebi.mdk.domain.entity.reaction.MetabolicReaction;
import uk.ac.ebi.mdk.domain.identifier.basic.*;
import uk.ac.ebi.mnb.core.ControllerAction;
import uk.ac.ebi.mnb.interfaces.MainController;

import java.awt.event.ActionEvent;

/**
 * @author John May
 */
public class ReassignIdentifiers extends ControllerAction {

    private static final Logger LOGGER = Logger.getLogger(ReassignIdentifiers.class);

    public ReassignIdentifiers(MainController controller) {
        super(ReassignIdentifiers.class.getSimpleName(), controller);
    }

    @Override
    public void actionPerformed(ActionEvent e) {

        for (Entity entity : getSelection().get(Metabolite.class)) {
            entity.setIdentifier(BasicChemicalIdentifier.nextIdentifier());
        }
        for (Entity entity : getSelection().get(MetabolicReaction.class)) {
            entity.setIdentifier(BasicReactionIdentifier.nextIdentifier());
        }
        for (Entity entity : getSelection().get(Gene.class)) {
            entity.setIdentifier(BasicGeneIdentifier.nextIdentifier());
        }
        for (Entity entity : getSelection().get(ProteinProduct.class)) {
            entity.setIdentifier(BasicProteinIdentifier.nextIdentifier());
        }
        for (Entity entity : getSelection().get(RNAProduct.class)) {
            entity.setIdentifier(BasicRNAIdentifier.nextIdentifier());
        }

        update(getSelection());

    }

}
